diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
index 5a4dd0935..ff4b727cf 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
@@ -1,10 +1,10 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.core.block.Blocks;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.render.EntityRenderDispatcher;
-import net.minecraft.client.render.Font;
 import net.minecraft.client.render.ImageParser;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.TextureManager;
@@ -284,7 +284,7 @@ public abstract class EntityRenderer<T extends Entity>
         }
     }
 
-    public Font getFont()
+    public FontRenderer getFont()
     {
         return renderDispatcher.getFont();
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
index 771a96bfe..63392a634 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
@@ -2,8 +2,9 @@ package net.minecraft.client.render.entity;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.Font;
 import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.model.ModelBase;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
@@ -215,14 +216,14 @@ public class MobRenderer<T extends Mob> extends EntityRenderer<T>
         }
     }
 
-    protected void renderLivingLabel(Tessellator tessellator, T entity, String s, double x, double y, double z, int maxDistance, boolean depthTest)
+    protected void renderLivingLabel(Tessellator t, T entity, String s, double x, double y, double z, int maxDistance, boolean depthTest)
     {
         final float f = (float) renderDispatcher.camera.distanceTo(entity);
         if (f > maxDistance)
         {
             return;
         }
-        final Font font = getFont();
+        final FontRenderer sr = getFont();
         final float f1 = 1.6F;
         final float f2 = 0.01666667F * f1;
         GL11.glPushMatrix();
@@ -238,19 +239,19 @@ public class MobRenderer<T extends Mob> extends EntityRenderer<T>
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
         byte byte0 = 0;
         GL11.glDisable(3553 /* GL_TEXTURE_2D */);
-        tessellator.startDrawingQuads();
-        final int j = font.getStringWidth(s) / 2;
-        tessellator.setColorRGBA_F(0.0F, 0.0F, 0.0F, 0.25F);
-        tessellator.addVertex(-j - 1, -1 + byte0, 0.0D);
-        tessellator.addVertex(-j - 1, 8 + byte0, 0.0D);
-        tessellator.addVertex(j + 1, 8 + byte0, 0.0D);
-        tessellator.addVertex(j + 1, -1 + byte0, 0.0D);
-        tessellator.draw();
+        t.startDrawingQuads();
+        final int j = sr.stringWidth(s) / 2;
+        t.setColorRGBA_F(0.0F, 0.0F, 0.0F, 0.25F);
+        t.addVertex(-j - 1, -1 + byte0, 0.0D);
+        t.addVertex(-j - 1, 8 + byte0, 0.0D);
+        t.addVertex(j + 1, 8 + byte0, 0.0D);
+        t.addVertex(j + 1, -1 + byte0, 0.0D);
+        t.draw();
         GL11.glEnable(3553 /* GL_TEXTURE_2D */);
-        font.drawString(s, -font.getStringWidth(s) / 2, byte0, 0x20ffffff);
+        FontHelper.render(t, s, -sr.stringWidth(s) / 2, byte0).setColor(0x20ffffff).call(sr);
         if (!depthTest) GL11.glEnable(2929 /* GL_DEPTH_TEST */);
         GL11.glDepthMask(true);
-        font.drawString(s, -font.getStringWidth(s) / 2, byte0, 0xFFFFFF);
+        FontHelper.render(t, s, -sr.stringWidth(s) / 2, byte0).setColor(0xFFFFFF).call(sr);
         GL11.glEnable(2896 /* GL_LIGHTING */);
         GL11.glDisable(3042 /* GL_BLEND */);
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
index 5ef2d7207..4ed76a5e9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
@@ -2,13 +2,13 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
 
-import net.minecraft.client.entity.player.PlayerLocal;
 import net.minecraft.client.render.TileEntityRenderDispatcher;
-import net.minecraft.client.render.Font;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.PlayerSkinParser;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.tileentity.TileEntityRenderer;
 import net.minecraft.client.render.camera.EntityCamera;
 import net.minecraft.client.render.model.ModelPlayer;
@@ -112,7 +112,7 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
         }
     }
     @Override
-    protected void renderSpecials(Tessellator tessellator, Player entity, double x, double y, double z)
+    protected void renderSpecials(Tessellator t, Player entity, double x, double y, double z)
     {
         if (Minecraft.getMinecraft().thePlayer.getGamemode() != Gamemode.spectator && entity.getGamemode() == Gamemode.spectator) {
             return;
@@ -134,14 +134,14 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
                 {
                     if(entity.isPlayerSleeping())
                     {
-                        renderLivingLabel(tessellator, entity, s, x, y - 1.5D, z, 64, false);
+                        renderLivingLabel(t, entity, s, x, y - 1.5D, z, 64, false);
                     } else
                     {
-                        renderLivingLabel(tessellator, entity, s, x, y, z, 64, false);
+                        renderLivingLabel(t, entity, s, x, y, z, 64, false);
                     }
                 } else
                 {
-                    Font font = getFont();
+                    final FontRenderer font = getFont();
                     GL11.glPushMatrix();
                     GL11.glTranslatef((float) x + 0.0F, (float) y + 2.3F, (float) z);
                     GL11.glNormal3f(0.0F, 1.0F, 0.0F);
@@ -154,17 +154,17 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
                     GL11.glEnable(GL11.GL_BLEND);
                     GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
                     GL11.glDisable(GL11.GL_TEXTURE_2D);
-                    tessellator.startDrawingQuads();
-                    int i = font.getStringWidth(s) / 2;
-                    tessellator.setColorRGBA_F(0.0F, 0.0F, 0.0F, 0.25F);
-                    tessellator.addVertex(-i - 1, -1D, 0.0D);
-                    tessellator.addVertex(-i - 1, 8D, 0.0D);
-                    tessellator.addVertex(i + 1, 8D, 0.0D);
-                    tessellator.addVertex(i + 1, -1D, 0.0D);
-                    tessellator.draw();
+                    t.startDrawingQuads();
+                    final int halfWidth = font.stringWidth(s) / 2;
+                    t.setColorRGBA_F(0.0F, 0.0F, 0.0F, 0.25F);
+                    t.addVertex(-halfWidth - 1, -1D, 0.0D);
+                    t.addVertex(-halfWidth - 1, 8D, 0.0D);
+                    t.addVertex(halfWidth + 1, 8D, 0.0D);
+                    t.addVertex(halfWidth + 1, -1D, 0.0D);
+                    t.draw();
                     GL11.glEnable(GL11.GL_TEXTURE_2D);
                     GL11.glDepthMask(true);
-                    font.drawString(s, -font.getStringWidth(s) / 2, 0, 0x20ffffff);
+                    FontHelper.renderCentered(t, s, 0, 0).setColor(0x20ffffff).call(font);
                     GL11.glEnable(GL11.GL_LIGHTING);
                     GL11.glDisable(GL11.GL_BLEND);
                     GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/Alignment.java b/game/client/src/main/java/net/minecraft/client/render/font/Alignment.java
new file mode 100644
index 000000000..cfe93d5d1
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/font/Alignment.java
@@ -0,0 +1,8 @@
+package net.minecraft.client.render.font;
+
+public enum Alignment {
+    LEFT,
+    RIGHT,
+//    JUSTIFIED,
+    CENTERED;
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/Font.java b/game/client/src/main/java/net/minecraft/client/render/font/Font.java
new file mode 100644
index 000000000..bdc0c87fd
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/font/Font.java
@@ -0,0 +1,26 @@
+package net.minecraft.client.render.font;
+
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texturepack.TexturePackList;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Random;
+
+public interface Font {
+
+    void init(@NotNull TexturePackList packList);
+
+    int textureForChar(char c);
+    char getObfuscatedChar(char c, Random random);
+    boolean canRenderChar(char c);
+
+    double charWidthDouble(char c);
+    default int charWidth(final char c) {
+        return MathHelper.ceil(charWidthDouble(c));
+    }
+
+    int fontHeight();
+
+    double renderChar(Tessellator tessellator, char c, double x, double y, double z, boolean italics);
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontDefault.java b/game/client/src/main/java/net/minecraft/client/render/font/FontDefault.java
new file mode 100644
index 000000000..a10d064a5
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontDefault.java
@@ -0,0 +1,83 @@
+package net.minecraft.client.render.font;
+
+import net.minecraft.client.render.TextureManager;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.Texture;
+import net.minecraft.core.util.helper.ChatAllowedCharacters;
+import org.jetbrains.annotations.NotNull;
+
+public class FontDefault extends FontFile {
+    public FontDefault(final @NotNull TextureManager textureManager) {
+        super(textureManager, "/font/font_%02X.png", "/font/glyph_sizes_default.bin");
+    }
+
+    @Override
+    public boolean canRenderChar(final char c) {
+        return c == ' ' || (!DEFAULT_BLACKLIST.contains(c) && ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c) >= 0 && textureForChar(c) != 0);
+//        return false;
+    }
+
+    @Override
+    public int textureForChar(final char c) {
+        final int fontIndex = ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c);
+        if (fontIndex < 0) return 0;
+        final int index = fontIndex / GLYPHS_PER_TEXTURE;
+        if (this.texHandleCache[index] != TEXTURE_UNASSIGNED) return this.texHandleCache[index];
+        final Texture texture = this.textureManager.loadTextureNoDefault(String.format(this.textureFormat, index));
+        if (texture == null) {
+            this.texHandleCache[index] = 0;
+            return 0;
+        }
+        this.texHandleCache[index] = texture.id();
+        return texture.id();
+    }
+
+    @Override
+    public double charWidthDouble(final char c) {
+        if (c == ' ') return 4;
+        final int fontIndex = ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c);
+        if (fontIndex < 0) return 0;
+
+        final int upper = this.charWidth[fontIndex] >> 4;
+        final int lower = this.charWidth[fontIndex] & 0x0F;
+        final double fUpper = upper;
+        final double fLower = (lower + 1);
+
+        return (fLower - fUpper) / 2.0D + 1;
+    }
+
+    @Override
+    public double renderChar(final Tessellator tessellator, final char c, final double x, final double y, final double z, final boolean italics) {
+        if (c == ' ') return 4;
+        final int fontIndex = ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c);
+        if (fontIndex < 0) return 0;
+
+        final int shift = italics ? ITALICS_SHIFT : 0;
+
+        final int upper = this.charWidth[fontIndex] >> 4;
+        final int lower = this.charWidth[fontIndex] & 0x0F;
+        final double fUpper = upper;
+        final double fLower = (lower + 1);
+        if (fLower - fUpper == 0) return 0;
+
+        final double epsilon = 0.02/256;
+        final double u = (fontIndex % 16 * 16) + fUpper;
+        final double v = (fontIndex & 255) / 16 * 16;
+        final double uWidth = fLower - fUpper;
+        final double vHeight = 16d;
+
+        final double uMin = u / 256d;
+        final double uMax = (u + uWidth) / 256d;
+        final double vMin = v / 256d;
+        final double vMax = (v + vHeight) / 256d;
+
+        final double width = uWidth/2d;
+        final double height = vHeight/2d;
+
+        tessellator.addVertexWithUV(x + shift,          y,           z, uMin + epsilon, vMin + epsilon);
+        tessellator.addVertexWithUV(x - shift,          y + height,  z, uMin + epsilon, vMax - epsilon);
+        tessellator.addVertexWithUV(x - shift + width,  y + height,  z, uMax - epsilon, vMax - epsilon);
+        tessellator.addVertexWithUV(x + shift + width,  y,           z, uMax - epsilon, vMin + epsilon);
+        return (fLower - fUpper)/2 + 1;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontFile.java b/game/client/src/main/java/net/minecraft/client/render/font/FontFile.java
new file mode 100644
index 000000000..a19072aff
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontFile.java
@@ -0,0 +1,135 @@
+package net.minecraft.client.render.font;
+
+import net.minecraft.client.render.TextureManager;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.Texture;
+import net.minecraft.client.render.texturepack.TexturePackList;
+import net.minecraft.core.util.helper.ChatAllowedCharacters;
+import org.jetbrains.annotations.NotNull;
+
+import java.io.IOException;
+import java.io.InputStream;
+import java.util.Arrays;
+import java.util.List;
+import java.util.Random;
+
+public class FontFile implements Font {
+    /**
+     * Some characters somehow are recognized as "default" characters while their rendering is not supported.
+     * Have to delete this once workarounds are found.
+     */
+    protected static final List<Character> DEFAULT_BLACKLIST = Arrays.asList(
+        '\uff0c', '\u3002', '\u3001', '\u3010', '\u3011', '\uff1b', '\u2019', '\u2018', '\u201c', '\u201d', '\uff1f', '\uff01', '\u00b7'
+    );
+
+    protected static final int ITALICS_SHIFT = 1;
+    protected static final int GLYPHS_PER_TEXTURE = 256;
+    protected static final int TEXTURE_UNASSIGNED = -1;
+
+    protected final byte[] charWidth;
+    protected final int[] texHandleCache;
+
+    protected final @NotNull String textureFormat;
+    protected final @NotNull String glyphSizesPath;
+    protected final @NotNull TextureManager textureManager;
+
+    public FontFile(final @NotNull TextureManager textureManager, @NotNull final String texturesFormat, @NotNull final String glyphSizesPath) {
+        this.textureManager = textureManager;
+        this.textureFormat = texturesFormat;
+        this.glyphSizesPath = glyphSizesPath;
+        this.charWidth = new byte[Character.MAX_VALUE + 1];
+        this.texHandleCache = new int[256];
+    }
+
+    @Override
+    public void init(@NotNull final TexturePackList packList) {
+        Arrays.fill(this.texHandleCache, TEXTURE_UNASSIGNED);
+
+        try (final InputStream glyphStreamDefault = packList.getResourceAsStream(this.glyphSizesPath)) {
+            glyphStreamDefault.read(this.charWidth);
+        } catch (final IOException e) {
+            throw new RuntimeException(e);
+        }
+    }
+
+    @Override
+    public int textureForChar(final char c) {
+        final int index = c / GLYPHS_PER_TEXTURE;
+        if (this.texHandleCache[index] != TEXTURE_UNASSIGNED) return this.texHandleCache[index];
+        final Texture texture = this.textureManager.loadTextureNoDefault(String.format(this.textureFormat, index));
+        if (texture == null) {
+            this.texHandleCache[index] = 0;
+            return 0;
+        }
+        this.texHandleCache[index] = texture.id();
+        return texture.id();
+    }
+
+    @Override
+    public char getObfuscatedChar(final char c, final Random random) {
+        if (ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c) < 0) return c;
+        char randomChar;
+        int counter = 0;
+        do {
+            randomChar = ChatAllowedCharacters.ALLOWED_CHARACTERS.charAt(random.nextInt(ChatAllowedCharacters.ALLOWED_CHARACTERS.length()));
+            if (counter++ > 1000) {
+                randomChar = c;
+                break;
+            }
+        } while (charWidth(c) != charWidth(randomChar) || !canRenderChar(randomChar));
+        return randomChar;
+    }
+
+    @Override
+    public boolean canRenderChar(final char c) {
+        return c == ' ' || textureForChar(c) != 0;
+    }
+
+    @Override
+    public double charWidthDouble(final char c) {
+        if (c == ' ') return 4;
+        final int upper = this.charWidth[c] >> 4;
+        final int lower = this.charWidth[c] & 0x0F;
+        final double fUpper = upper;
+        final double fLower = (lower + 1);
+
+        return (fLower - fUpper) / 2.0D + 1;
+    }
+
+    @Override
+    public int fontHeight() {
+        return 8;
+    }
+
+    @Override
+    public double renderChar(final Tessellator tessellator, final char c, final double x, final double y, final double z, final boolean italics) {
+        if (c == ' ') return 4;
+        final int shift = italics ? ITALICS_SHIFT : 0;
+
+        final int upper = this.charWidth[c] >> 4;
+        final int lower = this.charWidth[c] & 0x0F;
+        final double fUpper = upper;
+        final double fLower = (lower + 1);
+        if (fLower - fUpper == 0) return 0;
+
+        final double epsilon = 0.02/256;
+        final double u = (c % 16 * 16) + fUpper;
+        final double v = (c & 255) / 16 * 16;
+        final double uWidth = fLower - fUpper;
+        final double vHeight = 16d;
+
+        final double uMin = u / 256d;
+        final double uMax = (u + uWidth) / 256d;
+        final double vMin = v / 256d;
+        final double vMax = (v + vHeight) / 256d;
+
+        final double width = uWidth/2d;
+        final double height = vHeight/2d;
+
+        tessellator.addVertexWithUV(x + shift,          y,           z, uMin + epsilon, vMin + epsilon);
+        tessellator.addVertexWithUV(x - shift,          y + height,  z, uMin + epsilon, vMax - epsilon);
+        tessellator.addVertexWithUV(x - shift + width,  y + height,  z, uMax - epsilon, vMax - epsilon);
+        tessellator.addVertexWithUV(x + shift + width,  y,           z, uMax - epsilon, vMin + epsilon);
+        return (fLower - fUpper)/2 + 1;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontMonospace.java b/game/client/src/main/java/net/minecraft/client/render/font/FontMonospace.java
new file mode 100644
index 000000000..84e168513
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontMonospace.java
@@ -0,0 +1,66 @@
+package net.minecraft.client.render.font;
+
+import net.minecraft.client.render.TextureManager;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texturepack.TexturePackList;
+import net.minecraft.core.util.helper.ChatAllowedCharacters;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Arrays;
+
+public class FontMonospace extends FontFile{
+    public static final int MONOSPACE_WIDTH = 10;
+
+    public FontMonospace(final @NotNull TextureManager textureManager) {
+        super(textureManager, "/font/mono_%02X.png", "");
+    }
+
+    @Override
+    public void init(@NotNull final TexturePackList packList) {
+        Arrays.fill(this.texHandleCache, TEXTURE_UNASSIGNED);
+        Arrays.fill(this.charWidth, (byte) MONOSPACE_WIDTH);
+    }
+
+    @Override
+    public boolean canRenderChar(final char c) {
+        return !DEFAULT_BLACKLIST.contains(c) && ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c) != -1 && (c == ' ' || textureForChar(c) != 0);
+    }
+
+    @Override
+    public double charWidthDouble(final char c) {
+        return MONOSPACE_WIDTH / 2d + 1;
+    }
+
+    @Override
+    public double renderChar(final Tessellator tessellator, final char c, final double x, final double y, final double z, final boolean italics) {
+        if (c != ' ') {
+            final int shift = italics ? ITALICS_SHIFT : 0;
+            final int fontIndex = ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c);
+            if (fontIndex < 0) return 0;
+
+            final double epsilon = 0.02/256;
+            final int upper = this.charWidth[fontIndex] >> 4;
+            final int lower = this.charWidth[fontIndex] & 0x0F;
+            final double fUpper = upper;
+            final double fLower = (lower + 1);
+            final double u = (fontIndex % 16 * 16) + fUpper;
+            final double v = (fontIndex & 255) / 16 * 16;
+            final double uWidth = fLower - fUpper;
+            final double vHeight = 16d;
+
+            final double uMin = u / 256d;
+            final double uMax = (u + uWidth) / 256d;
+            final double vMin = v / 256d;
+            final double vMax = (v + vHeight) / 256d;
+
+            final double width = uWidth/2d;
+            final double height = vHeight/2d;
+
+            tessellator.addVertexWithUV(x + shift,          y,           z, uMin + epsilon, vMin + epsilon);
+            tessellator.addVertexWithUV(x - shift,          y + height,  z, uMin + epsilon, vMax - epsilon);
+            tessellator.addVertexWithUV(x - shift + width,  y + height,  z, uMax - epsilon, vMax - epsilon);
+            tessellator.addVertexWithUV(x + shift + width,  y,           z, uMax - epsilon, vMin + epsilon);
+        }
+        return MONOSPACE_WIDTH / 2d + 1;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontRenderer.java b/game/client/src/main/java/net/minecraft/client/render/font/FontRenderer.java
new file mode 100644
index 000000000..ce7182b92
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontRenderer.java
@@ -0,0 +1,29 @@
+package net.minecraft.client.render.font;
+
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.List;
+
+public interface FontRenderer extends Font {
+    void render(@NotNull Tessellator tessellator, @NotNull CharSequence chars, int x, int y, double z, boolean shadow, long baseConfig, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
+    void renderDouble(@NotNull Tessellator tessellator, @NotNull CharSequence chars, double x, double y, double z, boolean shadow, long baseConfig, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
+    void renderCentered(@NotNull Tessellator tessellator, @NotNull CharSequence chars, int x, int y, double z, boolean shadow, long baseConfig, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
+    void renderCenteredDouble(@NotNull Tessellator tessellator, @NotNull CharSequence chars, double x, double y, double z, boolean shadow, long baseConfig, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
+    void renderWidthConstrained(@NotNull Tessellator tessellator, @NotNull CharSequence chars, int x, int y, double z, boolean shadow, long baseConfig, int maxWidth, @NotNull Alignment alignment, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
+    void renderWidthConstrainedDouble(@NotNull Tessellator tessellator, @NotNull CharSequence chars, double x, double y, double z, boolean shadow, long baseConfig, double maxWidth, @NotNull Alignment alignment, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
+    void renderConstrained(@NotNull Tessellator tessellator, @NotNull CharSequence chars, int x, int y, double z, boolean shadow, long baseConfig, int maxWidth, int maxHeight, @NotNull Alignment alignment, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
+    void renderConstrainedDouble(@NotNull Tessellator tessellator, @NotNull CharSequence chars, double x, double y, double z, boolean shadow, long baseConfig, double maxWidth, double maxHeight, @NotNull Alignment alignment, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
+
+    @NotNull List<String> splitCharsIntoLines(@NotNull CharSequence chars, double maxWidth, @Nullable List<String> output);
+    @NotNull List<String> splitLinesIntoConstrainedLines(@NotNull List<String> lines, double maxWidth, @Nullable List<String> output);
+    double heightOfConstrainedChars(@NotNull CharSequence chars, double maxWidth);
+    double heightOfLines(@NotNull List<String> lines, double maxWidth);
+
+    double stringWidthDouble(CharSequence chars);
+    default int stringWidth(final CharSequence chars) {
+        return MathHelper.ceil(stringWidthDouble(chars));
+    }
+}
